package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Tforbid;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Forbid;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.ForbidServiceI;

@Service("forbidService")
public class ForbidServiceImpl extends BaseServiceImpl implements
		ForbidServiceI {

	private BaseDaoI<Tforbid> forbidDao;

	public BaseDaoI<Tforbid> getForbidDao() {
		return forbidDao;
	}

	@Autowired
	public void setForbidDao(BaseDaoI<Tforbid> forbidDao) {
		this.forbidDao = forbidDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Forbid forbid) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(forbid)));
		j.setTotal(total(forbid));
		return j;
	}

	private List<Forbid> changeModel(List<Tforbid> tforbids) {
		List<Forbid> forbids = new ArrayList<Forbid>();
		if (tforbids != null && tforbids.size() > 0) {
			for (Tforbid tb : tforbids) {
				Forbid b = new Forbid();
				BeanUtils.copyProperties(tb, b);
				forbids.add(b);
			}
		}
		return forbids;
	}

	private List<Tforbid> find(Forbid forbid) {
		String hql = "from Tforbid t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(forbid, hql, values);

		if (forbid.getSort() != null && forbid.getOrder() != null) {
			hql += " order by " + forbid.getSort() + " " + forbid.getOrder();
		}
		return forbidDao.find(hql, values, forbid.getPage(), forbid.getRows());
	}

	private Long total(Forbid forbid) {
		String hql = "select count(*) from Tforbid t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(forbid, hql, values);
		return forbidDao.count(hql, values);
	}

	private String addWhere(Forbid forbid, String hql, List<Object> values) {

		return hql;
	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				Tforbid t = forbidDao.get(Tforbid.class, id);
				if (t != null) {
					forbidDao.delete(t);
				}
			}
		}
	}

	public void add(Forbid forbid) {

		Tforbid t = new Tforbid();
		BeanUtils.copyProperties(forbid, t);
		t.setId(UUID.randomUUID().toString());
		// t.setState("0");
		t.setAdddate(new Date());
		t.setUpdatedate(new Date());
		forbidDao.save(t);
	}

	public void update(Forbid forbid) {
		Tforbid t = forbidDao.get(Tforbid.class, forbid.getId());
		if (t != null) {
			t.setCardcode(forbid.getCardcode());
			t.setState(forbid.getState());
			// t.setAdddate(forbid.getAdddate());
			t.setUpdatedate(new Date());

		}
	}

	public void deleteall() {
		// TODO Auto-generated method stub
		forbidDao.executeHql("delete Tforbid");

	}

	public void disableall() {
		// TODO Auto-generated method stub
		forbidDao.executeHql("update Tforbid set state = '1'");
	}

	public void enableall() {
		// TODO Auto-generated method stub
		forbidDao.executeHql("update Tforbid set state = '0'");

	}

}
