package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.dj.dao.base.BaseDaoI;
import com.dj.exception.ValidateFieldsException;

import com.dj.model.sys.Tminearea;
import com.dj.model.sys.Tleader;

import com.dj.model.sys.Vleader;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Leader;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.LeaderServiceI;

@Service("leaderService")
public class LeaderServiceImpl extends BaseServiceImpl implements
		LeaderServiceI {

	private BaseDaoI<Tleader> leaderDao;
	private BaseDaoI<Vleader> vleaderDao;

	private BaseDaoI<Tminearea> mineareaDao;
	// 增加岗位和班组


	public BaseDaoI<Tleader> getLeaderDao() {
		return leaderDao;
	}

	@Autowired
	public void setLeaderDao(BaseDaoI<Tleader> leaderDao) {
		this.leaderDao = leaderDao;
	}
	
	public BaseDaoI<Vleader> getVleaderDao() {
		return vleaderDao;
	}

	@Autowired
	public void setVleaderDao(BaseDaoI<Vleader> vleaderDao) {
		this.vleaderDao = vleaderDao;
	}



	public BaseDaoI<Tminearea> getMineareaDao() {
		return mineareaDao;
	}

	@Autowired
	public void setMineareaDao(BaseDaoI<Tminearea> mineareaDao) {
		this.mineareaDao = mineareaDao;
	}

	

	public void save(Leader leader) throws ValidateFieldsException {
		Tleader u = new Tleader();

		
		u.setLeadername(leader.getLeadername());
		u.setState(leader.getState());

		u.setId(UUID.randomUUID().toString());
		
		u.setTminearea(mineareaDao.get(Tminearea.class,
				leader.getMineareacode()));
		

		leaderDao.save(u);

	}

	public void update(Leader leader) throws ValidateFieldsException {

		Tleader u = leaderDao
				.get(Tleader.class, leader.getId());

		if (u != null) {
			

			u.setState(leader.getState());
			u.setLeadername(leader.getLeadername());
		
			u.setTminearea(mineareaDao.get(Tminearea.class,
					leader.getMineareacode()));
			
		}

	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Leader leader) {
		DataGrid j = new DataGrid();
		j.setRows(this.changeModel(this.find(leader)));
		j.setTotal(this.total(leader));
		return j;
	}

	// 这里没加上id remark
	//
	private List<Leader> changeModel(List<Vleader> tleaders) {
		List<Leader> leaders = new ArrayList<Leader>();
		if (tleaders != null && tleaders.size() > 0) {
			for (Vleader tu : tleaders) {
				Leader u = new Leader();

				u.setId(tu.getId());
				
				u.setLeadername(tu.getLeadername());
				u.setState(tu.getState());
				
				u.setMineareacode(tu.getMineareacode());
				u.setMineareaname(tu.getMineareaname());
				


				leaders.add(u);
			}
		}
		return leaders;
	}

	//private List find(Leader leader) {
	private List<Vleader> find(Leader leader) {
		String hql = "from Vleader t where 1=1 ";
		//String hql = "select t.id,t.personcode,t.personname,t.personsex,t.personphone,t.cardcode,t.zigbee from Tleader t left join t.tminearea t1 where 1=1";
		 ///  Query q = session.createQuery("select t.topic_title, c.category_name from Topic t join t.category c "); //join Category c  
		//User u left join u.gender

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(leader, hql, values);

		if (leader.getSort() != null && leader.getOrder() != null) {
			hql += " order by " + leader.getSort() + " "
					+ leader.getOrder();
		}
		//System.out.println(hql);
		return vleaderDao.find(hql, values, leader.getPage(),
				leader.getRows());
	}

	private Long total(Leader leader) {
		String hql = "select count(*) from Vleader t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(leader, hql, values);
		return vleaderDao.count(hql, values);
	}

	private String addWhere(Leader leader, String hql,
			List<Object> values) {
		if (leader.getLeadername() != null
				&& !leader.getLeadername().trim().equals("")) {
			hql += " and t.leadername like ? ";
			values.add("%%" + leader.getLeadername().trim() + "%%");
		}
		
		
		if(leader.getMineareacode() != null && !leader.getMineareacode().trim().equals(""))
		{
			hql += " and t.mineareacode = ?";
			//System.out.println(leader.getMineareacode());
        	values.add(leader.getMineareacode());
		}
		


		return hql;
	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				Tleader t = leaderDao.get(Tleader.class, id);
				if (t != null) {
					leaderDao.delete(t);
				}
			}
		}
	}

}
