package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Vlowpower;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Lowpower;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.LowpowerServiceI;

@Service("lowpowerService")
public class LowpowerServiceImpl extends BaseServiceImpl implements
		LowpowerServiceI {

	private BaseDaoI<Vlowpower> lowpowerDao;

	public BaseDaoI<Vlowpower> getLowpowerDao() {
		return lowpowerDao;
	}

	@Autowired
	public void setLowpowerDao(BaseDaoI<Vlowpower> lowpowerDao) {
		this.lowpowerDao = lowpowerDao;
	}

	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Lowpower lowpower) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(lowpower)));
		j.setTotal(total(lowpower));
		return j;
	}

	private List<Lowpower> changeModel(List<Vlowpower> tlowpowers) {
		List<Lowpower> lowpowers = new ArrayList<Lowpower>();
		if (tlowpowers != null && tlowpowers.size() > 0) {
			for (Vlowpower tb : tlowpowers) {
				Lowpower b = new Lowpower();
				BeanUtils.copyProperties(tb, b);
				

				lowpowers.add(b);
			}
		}
		return lowpowers;
	}

	private List<Vlowpower> find(Lowpower lowpower) {
		String hql = "from Vlowpower t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(lowpower, hql, values);

		if (lowpower.getSort() != null && lowpower.getOrder() != null) {
			hql += " order by " + lowpower.getSort() + " "
					+ lowpower.getOrder();
		}
		return lowpowerDao.find(hql, values, lowpower.getPage(),
				lowpower.getRows());
	}

	
	private Long total(Lowpower lowpower) {
		String hql = "select count(*) from Vlowpower t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(lowpower, hql, values);
		return lowpowerDao.count(hql, values);
	}

	private String addWhere(Lowpower lowpower, String hql,
			List<Object> values) {
		
		
		if (lowpower.getPersonname() != null
				&& !"".equals(lowpower.getPersonname())) {
			hql += " and t.personname = ?";
			values.add(lowpower.getPersonname());
		}
		
		if (lowpower.getCardcode() != null
				&& !"".equals(lowpower.getCardcode())) {
			hql += " and t.cardcode = ?";
			values.add(lowpower.getCardcode());
		}

		
		if (lowpower.getMineareacode() != null
				&& !lowpower.getMineareacode().trim().equals("")) {
			hql += " and t.mineareacode = ?";
			values.add(lowpower.getMineareacode());
		}

		
		return hql;
	}

}
