package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import org.apache.struts2.ServletActionContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.dj.dao.base.BaseDaoI;
import com.dj.exception.ValidateFieldsException;
import com.dj.model.sys.Tarea;
import com.dj.model.sys.Tdept;
import com.dj.model.sys.Tgroup;
import com.dj.model.sys.Tminearea;
import com.dj.model.sys.Tpersoninfo;
import com.dj.model.sys.Tpost;
import com.dj.model.sys.Vpersoninfo;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Personinfo;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.PersoninfoServiceI;
import com.dj.util.base.ResourceUtil;

import com.dj.pageModel.base.SessionInfo;

@Service("personinfoService")
public class PersoninfoServiceImpl extends BaseServiceImpl implements
		PersoninfoServiceI {

	private BaseDaoI<Tpersoninfo> personinfoDao;
	private BaseDaoI<Vpersoninfo> vpersoninfoDao;
	private BaseDaoI<Tdept> deptDao;
	private BaseDaoI<Tarea> areaDao;
	private BaseDaoI<Tminearea> mineareaDao;
	// 增加岗位和班组
	private BaseDaoI<Tpost> postDao;
	private BaseDaoI<Tgroup> groupDao;

	public BaseDaoI<Tpersoninfo> getPersoninfoDao() {
		return personinfoDao;
	}

	@Autowired
	public void setPersoninfoDao(BaseDaoI<Tpersoninfo> personinfoDao) {
		this.personinfoDao = personinfoDao;
	}

	public BaseDaoI<Vpersoninfo> getVpersoninfoDao() {
		return vpersoninfoDao;
	}

	@Autowired
	public void setVpersoninfoDao(BaseDaoI<Vpersoninfo> vpersoninfoDao) {
		this.vpersoninfoDao = vpersoninfoDao;
	}

	public BaseDaoI<Tdept> getDeptDao() {
		return deptDao;
	}

	@Autowired
	public void setDeptDao(BaseDaoI<Tdept> deptDao) {
		this.deptDao = deptDao;
	}

	public BaseDaoI<Tarea> getAreaDao() {
		return areaDao;
	}

	@Autowired
	public void setAreaDao(BaseDaoI<Tarea> areaDao) {
		this.areaDao = areaDao;
	}

	public BaseDaoI<Tminearea> getMineareaDao() {
		return mineareaDao;
	}

	@Autowired
	public void setMineareaDao(BaseDaoI<Tminearea> mineareaDao) {
		this.mineareaDao = mineareaDao;
	}

	public BaseDaoI<Tpost> getPostDao() {
		return postDao;
	}

	@Autowired
	public void setPostDao(BaseDaoI<Tpost> postDao) {
		this.postDao = postDao;
	}

	public BaseDaoI<Tgroup> getGroupDao() {
		return groupDao;
	}

	@Autowired
	public void setGroupDao(BaseDaoI<Tgroup> groupDao) {
		this.groupDao = groupDao;
	}

	public void save(Personinfo personinfo) throws ValidateFieldsException {
		Tpersoninfo u = new Tpersoninfo();

		u.setPersoncode(personinfo.getPersoncode());
		u.setPersonname(personinfo.getPersonname());
		u.setCardcode(personinfo.getCardcode());
		u.setPersonsex(personinfo.getPersonsex());
		u.setPersonphone(personinfo.getPersonphone());
		u.setPersonhomephone(personinfo.getPersonhomephone());

		u.setId(UUID.randomUUID().toString());
		u.setTdept(deptDao.get(Tdept.class, personinfo.getDepartcode()));
		u.setTpost(postDao.get(Tpost.class, personinfo.getPostcode()));
		u.setTgroup(groupDao.get(Tgroup.class, personinfo.getGroupcode()));

		personinfoDao.save(u);

	}

	public void update(Personinfo personinfo) throws ValidateFieldsException {

		Tpersoninfo u = personinfoDao
				.get(Tpersoninfo.class, personinfo.getId());

		if (u != null) {
			u.setPersoncode(personinfo.getPersoncode());
			u.setPersonname(personinfo.getPersonname());
			u.setCardcode(personinfo.getCardcode());
			u.setPersonsex(personinfo.getPersonsex());
			u.setPersonphone(personinfo.getPersonphone());
			u.setPersonhomephone(personinfo.getPersonhomephone());

			u.setTdept(deptDao.get(Tdept.class, personinfo.getDepartcode()));
			u.setTpost(postDao.get(Tpost.class, personinfo.getPostcode()));
			u.setTgroup(groupDao.get(Tgroup.class, personinfo.getGroupcode()));
		}

	}



	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Personinfo personinfo) {
		DataGrid j = new DataGrid();
		j.setRows(this.changeModel(this.find(personinfo)));
		j.setTotal(this.total(personinfo));
		return j;
	}

	// 这里没加上id remark
	//
	private List<Personinfo> changeModel(List<Vpersoninfo> tpersoninfos) {
		List<Personinfo> personinfos = new ArrayList<Personinfo>();
		if (tpersoninfos != null && tpersoninfos.size() > 0) {
			for (Vpersoninfo tu : tpersoninfos) {
				Personinfo u = new Personinfo();

				u.setId(tu.getId());
				u.setPersoncode(tu.getPersoncode());
				u.setPersonname(tu.getPersonname());
				u.setCardcode(tu.getCardcode());
				// 增加性别、电话、家庭电话等
				u.setPersonsex(tu.getPersonsex());
				u.setPersonphone(tu.getPersonphone());
				u.setPersonhomephone(tu.getPersonhomephone());

				u.setDepartcode(tu.getDepartcode());
				u.setDepartname(tu.getDepartname());

				u.setGroupcode(tu.getGroupcode());
				u.setGroupname(tu.getGroupname());

				u.setPostcode(tu.getPostcode());
				u.setPostname(tu.getPostname());
//				//
//				u.setDepartcode(tu.getTdept().getCid());
//				u.setDepartname(tu.getTdept().getCname());
//				u.setAreacode(tu.getTarea().getCid());
//				u.setAreaname(tu.getTarea().getCname());
//				u.setMineareacode(tu.getTminearea().getCid());
//				u.setMineareaname(tu.getTminearea().getCname());
//
//				// 增加岗位和班组等
//				u.setPostcode(tu.getTpost().getCid());
//				u.setPostname(tu.getTpost().getCname());
//
//				u.setGroupcode(tu.getTgroup().getCid());
//				u.setGroupname(tu.getTgroup().getCname());

				u.setRemark(tu.getRemark());

				personinfos.add(u);
			}
		}
		return personinfos;
	}

	//private List find(Personinfo personinfo) {
	private List<Vpersoninfo> find(Personinfo personinfo) {

		SessionInfo sessionInfo = (SessionInfo) ServletActionContext.getRequest().getSession().getAttribute(ResourceUtil.getSessionInfoName());


		List<Object> values = new ArrayList<Object>();
		String hql = "";

		/*if("0".equals(mineareacode))
		{
			hql = "from Vpersoninfo t where 1=1 ";
		}
		else
		{

			values.add(mineareacode);
		}*/
		// lili 2015-03-23
		hql = "from Vpersoninfo t where 1=1";

		hql = addWhere(personinfo, hql, values);

		if (personinfo.getSort() != null && personinfo.getOrder() != null) {
			hql += " order by " + personinfo.getSort() + " "
					+ personinfo.getOrder();
		}
		System.out.println(hql+ "=====================test---======" );
		if (values.size() > 0) {
			System.out.println("======"+ values.get(0));
		}
		return vpersoninfoDao.find(hql, values, personinfo.getPage(),
				personinfo.getRows());
	}

	private Long total(Personinfo personinfo) {
		SessionInfo sessionInfo = (SessionInfo) ServletActionContext.getRequest().getSession().getAttribute(ResourceUtil.getSessionInfoName());

		List<Object> values = new ArrayList<Object>();

		String hql = "";
		/*if("0".equals(mineareacode))
		{
			hql = "select count(*) from Vpersoninfo t where 1=1 ";
		}
		else
		{
			hql = "select count(*) from Vpersoninfo t where t.mineareacode = ?";
			values.add(mineareacode);
		}*/
		hql = "select count(*) from Vpersoninfo t where 1=1 ";

		// lili 2015-03-23

		hql = addWhere(personinfo, hql, values);
		return vpersoninfoDao.count(hql, values);
	}

	private String addWhere(Personinfo personinfo, String hql,
			List<Object> values) {
		if (personinfo.getPersonname() != null
				&& !personinfo.getPersonname().trim().equals("")) {
			hql += " and t.personname like ? ";
			values.add("%" + personinfo.getPersonname().trim() + "%");
		}
		//卡号查询、矿区、区域、部门
		if(personinfo.getCardcode() != null && !personinfo.getCardcode().trim().equals(""))
		{
//			hql += " and (t.cardcode like ? or t.zigbee like ?)";
//			values.add("%%" + personinfo.getCardcode().trim() + "%%");
//			values.add("%%" + personinfo.getCardcode().trim() + "%%");
			hql += " and (t.cardcode = ? or t.zigbee = ?)";
			values.add(personinfo.getCardcode().trim());
			values.add(personinfo.getCardcode().trim());
		}


		if(personinfo.getDepartcode() != null && !personinfo.getDepartcode().trim().equals(""))
		{
			hql += " and t.departcode = ?";
			values.add(personinfo.getDepartcode());
			//values.add(new Tdept(personinfo.getDepartcode(),personinfo.getDepartname()));
		}
		//增加岗位和班组过滤
		if(personinfo.getPostcode() != null && !personinfo.getPostcode().trim().equals(""))
		{
			hql += " and t.postcode = ?";
			values.add(personinfo.getPostcode());

		}
		if(personinfo.getGroupcode() != null && !personinfo.getGroupcode().trim().equals(""))
		{
			hql += " and t.groupcode = ?";
			values.add(personinfo.getGroupcode());

		}

		return hql;
	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				Tpersoninfo t = personinfoDao.get(Tpersoninfo.class, id);
				if (t != null) {
					personinfoDao.delete(t);
				}
			}
		}
	}



	@Override
	public List<Tpersoninfo> findAllPerson() {
		String str= "from Tpersoninfo";
		List<Tpersoninfo> list = personinfoDao.find(str);
		return list;
	}
}
