//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

package com.dj.service.sys.impl;

import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.EnvRealModel;
import com.dj.model.sys.THeryanghuatan;
import com.dj.model.sys.THshidu;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.EryanghuatanHistory;
import com.dj.pageModel.sys.ShiduHistory;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.ShiduhistoryServiceI;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.transform.Transformers;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

@Service("shiduhistoryService")
public class ShiduhistoryServiceImpl extends BaseServiceImpl implements ShiduhistoryServiceI {

    private SessionFactory sessionFactory;

    public SessionFactory getSessionFactory() {
        return sessionFactory;
    }

    @Autowired
    public void setSessionFactory(SessionFactory sessionFactory) {
        this.sessionFactory = sessionFactory;
    }

    private Session getCurrentSession() {
        return sessionFactory.getCurrentSession();
    }

    private BaseDaoI<THshidu> shiduDao;

    public ShiduhistoryServiceImpl() {
    }

    public BaseDaoI<THshidu> getShiduDao() {
        return this.shiduDao;
    }

    @Autowired
    public void setShiduDao(BaseDaoI<THshidu> shiduDao) {
        this.shiduDao = shiduDao;
    }

    @Transactional(
            readOnly = true,
            propagation = Propagation.SUPPORTS
    )
    public DataGrid datagrid(ShiduHistory shidu) {
        DataGrid j = new DataGrid();
        j.setRows(this.changeModel(this.find(shidu)));
        j.setTotal(this.total(shidu));
        return j;
    }

    private List<ShiduHistory> changeModel(List<THshidu> tHshidus) {
        List<ShiduHistory> shiduHistories = new ArrayList();
        if (tHshidus != null && tHshidus.size() > 0) {
            Iterator var4 = tHshidus.iterator();

            while(var4.hasNext()) {
                THshidu tb = (THshidu)var4.next();
                ShiduHistory b = new ShiduHistory();
                BeanUtils.copyProperties(tb, b);
                shiduHistories.add(b);
            }
        }

        return shiduHistories;
    }

    private List<THshidu> find(ShiduHistory shiduHistory) {
        String hql = "from THshidu t where 1=1 ";
        List<Object> values = new ArrayList();
        hql = this.addWhere(shiduHistory, hql, values);
        if (shiduHistory.getSort() != null && shiduHistory.getOrder() != null) {
            hql = hql + " order by " + shiduHistory.getSort() + " " + shiduHistory.getOrder();
        }

        return this.shiduDao.find(hql, values, shiduHistory.getPage(), shiduHistory.getRows());
    }

    private Long total(ShiduHistory shiduHistory) {
        String hql = "select count(*) from THshidu t where 1=1 ";
        List<Object> values = new ArrayList();
        hql = this.addWhere(shiduHistory, hql, values);
        return this.shiduDao.count(hql, values);
    }

    private String addWhere(ShiduHistory shiduHistory, String hql, List<Object> values) {
        if (shiduHistory.getZduan() != null && !"".equals(shiduHistory.getZduan().trim())) {
            hql = hql + " and t.zduan like ? ";
            values.add("%%" + shiduHistory.getZduan().trim() + "%%");
        }

        if (shiduHistory.getSensorname() != null && !"".equals(shiduHistory.getSensorname().trim())) {
            hql = hql + " and t.sensorname like ? ";
            values.add("%%" + shiduHistory.getSensorname().trim() + "%%");
        }

        if (shiduHistory.getJctimeStart() != null) {
            hql = hql + " and t.jctime>=? ";
            values.add(shiduHistory.getJctimeStart());
        }

        if (shiduHistory.getJctimeEnd() != null) {
            hql = hql + " and t.jctime<=? ";
            values.add(shiduHistory.getJctimeEnd());
        }

        return hql;
    }

    @Override
    public List realTimeShidu() {
        String hql = "select a.id, a.zkname, a.sensorname, a.ifbj, a.jctime, a.value2 from (select id, zkname, sensorname, ifbj, jctime, value2, rank() over (Partition by sensorname order by jctime desc) " +
                "from tab_shidu) a where a.rank = 1 and jctime > (now() - interval '6 hour')";
        List list =getCurrentSession().createSQLQuery(hql).setResultTransformer(Transformers.aliasToBean(EnvRealModel.class)).list();
        return list;
    }
}
